<a name="ucf-scripts"></a>
# ucf-scripts

![](https://img.shields.io/npm/v/ucf-scripts.svg#id=gS7Q3&originHeight=20&originWidth=80&originalType=binary&ratio=1&rotation=0&showTitle=false&status=done&style=none&title=)<br />![](http://img.shields.io/npm/dt/ucf-scripts.svg?style=flat#id=K4kEm&originHeight=20&originWidth=104&originalType=binary&ratio=1&rotation=0&showTitle=false&status=done&style=none&title=)

---

![](https://nodei.co/npm/ucf-scripts.png#id=ZrebA&originHeight=56&originWidth=391&originalType=binary&ratio=1&rotation=0&showTitle=false&status=done&style=none&title=)

---

<a name="61a3ec66"></a>
## 介绍

集成了最新的技术栈包括`babel7,autoprefixer,less,postcss,webpack5`、高度封装、简化配置、无多余依赖、具有服务启动、开发调试、代理访问、数据模拟、构建资源、自动刷新功能。快速开发UCF微服务工程底层配套工具支撑，[详情文档](https://www.yuque.com/ucf-web/book/zfy8x1)

<a name="e655a410"></a>
## 安装

工具可以依赖UCF项目工程通过`scripts`运行

<a name="ecff77a8"></a>
## 使用

1. 通过`npm scripts`启动

配置精简<br />ui模板地址 [http://git.yonyou.com/yonyou-ide/tinper-next-packages/next-webapp](http://git.yonyou.com/yonyou-ide/tinper-next-packages/next-webapp) （ts项目切换为typescript分支）

```bash

# 开发启动
$ npm start

# 开发构建
$ npm run build

# 初始化模板
$ ucf-scripts init app1
在当前目录创建一个文件命是app1的模板项目
```

内置已经集成ucf-scripts的启动
<a name="bD9ex"></a>
## 命令行

- --port  本地启动端口
- --https 内置证书密钥，支持https启动服务
- --homepage  自动开启浏览器打开某个模块
- --mode=dev  构建开启调试模式，不启用代码压缩
```javascript
  "scripts": {
    "start": "ucf-scripts start --port=9000 --https --homepage=demo",
    "build": "ucf-scripts build --mode=dev"
  }
```


<a name="16083eb1"></a>
## 启动方式对比优劣

全局启动和项目内脚本启动区别：

| 启动方式 | 优点 | 缺点 |
| --- | --- | --- |
| 全局启动 | 无需根据项目一次次安装重复依赖npm包节省磁盘空间速度 | 不受项目内工具版本控制，会导致每个开发者环境不统一，出现未知版本错误等 |
| 脚本启动 | 无需管理全局环境变量、不污染全局变量、随时根据项目内版本更新、可控每一次版本 | 多次项目使用需要反复安装、占用磁盘空间大 |


<a name="6fc23a11"></a>
## 项目配置文件说明

UCF微服务前端工程核心配置文件只有一个`ucf.config.js`下面对配置文件说明：（默认精简）

```javascript

module.exports = (env, argv) => {
    return {
        // 启动所有模块，默认这个配置，速度慢的时候使用另外的配置
        bootList: true,
        // tns 统一入口名称
        bootName: 'bootstrap.js',
        // 代理的配置
        proxy: [
            {
                enable: true,
                headers: {
                    "Referer": "https://mock.yonyoucloud.com"
                },
                //要代理访问的对方路由
                router: [
                    '/mock'
                ],
                url: 'https://mock.yonyoucloud.com'
            }
        ],
        // 全局环境变量
        global_env: {
           GROBAL_HTTP_CTX: JSON.stringify("/iuap_demo"),
        },
        // 别名配置
        alias: {
            // 'ucf-apps': path.resolve(__dirname, 'ucf-apps/')
        },
        tnsCfg: {
          // 启用tns
          enabled: true
        },
    }
}
```

<a name="ce859785"></a>
## 功能配置节点说明

| **配置项** | **说明** | **默认值/类型** | **可选值** | **备注** | **版本** |
| --- | --- | --- | --- | --- | --- |
| bootList | 启动、构建入口配置，true表示所有模块全部启用，数组参数按需模块使用 | true | `true`<br />`['app-name']` | 一般默认开启所有模块的调试和构建，低配置机器或者只需要开发一块模块的话可以选择性的去配置单独启动 |  |
| bootName | 统一的 入口文件名称 如 bootstrap.js bootstrap.js 内容为: import('./app');如未设置添加则默认为 app.js(tns 不会生效); | `app.js` | `bootstrap.js` | 每个入口模块的src/app.js同级目录内必需包含一个该名称命名的文件 |  |
| proxy | 开发调试阶段的代理服务配置 | [] | `enable:true`<br /> 是否有效代理,false表示关闭. `headers:{}`<br /> 设置代理请求的消息头. `router:['/iuap','wbalone']`<br />. `url:'proxy.example.com'`<br />. 本地请求代理对方服务器地址. `pathRewrite:{}`<br />URL重写服务.  `opts:{}`<br /> 如内置配置无法满足需求，需要单独设置原生配置 [http-proxy-middleware](https://www.npmjs.com/package/http-proxy-middleware#options)<br />. | 数组节点可以配置多条代理服务，通过`enable`<br />来控制启用哪个，针对一些服务器校验头信息例如：`Referer`<br />等就需要设置，其他常规的设置工具已经内置，代理路由`router`<br />表示设置的几个路由访问后会代理到对方服务器上，`url`<br />就是对方服务器地址 |  |
| publicPath | 指定资源文件引用的目录，打包目录上下文 |  字符串｜对象 | '/'<br />{<br />output:'/',<br />img:'/',<br />icon:'/',<br />} | <br /> | 对象类型是3.0版本支持 |
| templateType | 入口文件模板类型 | html | ejs、html |  |  |
| global_env | 程序内公共变量 | null | 同webpack5 { key : value } | 接收K、V格式如：{GROBAL_HTTP_CTX: JSON.stringify("/iuap_demo")} |  |
| extensions | 自定义扩展 | 内置ts、tsx、js、jsx、less、json、css |  |  |  |
| externals | 排除指定的包用外部变量代理提升打包性能 | 内置<br />"react": "React",<br />"react-dom": "ReactDOM",<br />"@tinper/next-ui": "TinperNext", | 同webpack5 { key : value } | 接收K、V格式如：{'tinper-bee': 'TinperBee'} |  |
| alias | 别名 | null | 同webpack5 {key : value} | 接收K、V格式如：{'ucf-apps': path.resolve(__dirname, 'ucf-apps/')} |  |
| limit | 打包图片图标的限制文件大小 |  number｜object | '/'<br />{<br />img:'/',<br />icon:'/',<br />} |  | 对象类型是3.0版本支持 |
| static | 静态托管服务，不按需打包 | undefined | - | 脚手架内的任意文件夹即可，如：static : 'ucf-common/src/static' |  |
| scan_root | 自定义文件夹作为扫描微应用入口，原则上是按照./自定义目录/*/src/app.js扫描 | ucf-apps | - |  |  |
| dist_root | 输出自定义文件夹 | ucf-publish | - |  |  |
| host | 自定义IP、域名启动 | "127.0.0.1" | 支持IPV4、IPV6、域名 |  |  |
| tnsCfg | tns配置 | undefined | - | 默认不启用tns服务器，如需启用需配置 `{enabled: true, ...otherTnsPluginOptions}`<br />，otherTnsPluginOptions参考@tinper/next-plugin配置 |  |
| hash | 构建模式下，打包文件添加hash，文件指纹 | number &#124; object | {<br />js:8,<br />css:8<br />} | 生产阶段使用的 | 3.0版本支持 |
| devtool | webpack的devtool配置 | 开发模式默认为source-map<br />生产模式为false | - |  | 3.0版本支持 |
| webpackCfg | 最后执行，复写定制最终的webpack配置 | function | 具体用法见详细说明 |  | 3.0版本支持 |
| pluginCfg | 对webpack的plugin做的一些配置 | function｜object | 具体用法见详细说明 | 对象类型完全覆盖内置默认参数，函数类型可基于内置类型扩展 | 3.0版本支持 |
| loaderCfg | 对webpack的loader做的一些配置 | function｜object | 具体用法见详细说明 | 对象类型完全覆盖内置默认参数，函数类型可基于内置类型扩展 | 3.0版本支持 |
| ~~hasHash~~ | js文件打包添加hash | <br /> | <br /> | <br /> | 3.0版本已经去掉，建议用hash<br />2.0版本支持 |
| ~~open_source_map~~ | 构建资源生产环境的时候产出sourceMap | true | true,false | 废弃 | 3.0版本去掉，建议用devtool |
| ~~res_extra~~ | 是否展开静态引用资源，用于打包处理字体、图片等资源产出，或者不使用展开资源会打包到css方便管理 | true | true,false | 后续去掉 | 3.0版本已经去掉 |
| ~~css，~~ | css loader的options | undefined | - | 具体参考https://www.npmjs.com/package/css-loader |  |
| ~~less~~ | less loader的options | undefined | - | 具体参考https://www.npmjs.com/package/less-loader |  |
| ~~postcss_plugins~~ | `PostCss`<br /> Plugin | undefined | - |  |  |
| ~~babel_include~~ | `babel`<br />使用的 incluede | [] | (includes) => includes / array | 当在ie内存在如第三方包代码不兼容情况时 可在此配置解决 |  |
| ~~babel_presets~~ | `babel`<br />使用的 presets | undefined | - | 如：require.resolve('@babel/preset-react') |  |
| ~~babel_plugins~~ | `babel`<br />的插件 | undefined | 如：require.resolve("babel-plugin-import-bee") |  |  |
| ~~loader~~ | 内置加载器无法处理需要单独去设置处理 | [] | 同webpack5 loader |  |  |
| ~~devPlugins~~ | 开发环境加载的插件 | [] | 同webpack5<br />plugin | 开发阶段使用的插件 |  |
| ~~buildPlugins~~ | 生产环境加载的插件 | [] | 同webpack5 plugin | 生产阶段使用的插件 |  |
| ~~HtmlPluginConf~~ | HtmlWebPackPlugin插件的配置 | 见详细说明 |  | 内置默认配置，传入可以覆盖 |  |
| ~~splitChunks~~ | webpack的optimization下面的splitChunks配置 | 见详细说明 | 支持函数类型，默认配置传进去 | 内置默认配置，传入可以覆盖 |  |
|

<a name="NP3lH"></a>
## 详细说明
<a name="bRkts"></a>
### bootList
启动控制器，用于设置启动哪些微应用，可以单独启动某一处，也可以启动所有
```javascript
//单独启动所有ucf-apps下面的所有模块
bootList:true
```
```javascript
// 单独启动demo1、demo2
bootList: [
  "demo1",
  "demo2"
]
```
<a name="Qyvda"></a>
### bootName
统一的 入口文件名称 默认为app.js。每个微应用的入口都应该有一个app.js

- 用法

`bootName:"bootstrap.js"`<br />**接入tns的话入口文件改为bootstrap.js**
```javascript
// bootstrap.js
import('./app')
```
<a name="BxJSk"></a>
### proxy
<br />用于设置开发阶段的代理服务（生产构建发布无效），基于 [http-proxy-middleware](https://www.npmjs.com/package/http-proxy-middleware) 二次开发，可以使用默认参数快速使用，也可以使用原生`options`参数传入给中间件

- **用法**

```javascript
// 基础使用代理
proxy: [
  {
    // 启用、禁用该条规则
    enable: true,
    // 请求代理服务的消息头
    headers: {
      "Referer": "https://mock.yonyoucloud.com"
    },
    //本地路由代理到远端
    router: [
      '/mock'
    ],
    url: 'https://mock.yonyoucloud.com'
  }
]
```
启动调试服务后，本机开启：[http://127.0.0.1:3000/mock](http://127.0.0.1:3000/mock) 代理服务。例如访问：[http://127.0.0.1:3000/mock/843/basic](http://127.0.0.1:3000/mock/843/basic) 服务，代理会访问对方的主机服务为：[https://mock.yonyoucloud.com/mock/843/basic](https://mock.yonyoucloud.com/mock/843/basic)
```javascript
// 使用pathRewrite来改写我们请求的代理路由
proxy: [
  {
    // 启用、禁用该条规则
    enable: true,
    // 请求代理服务的消息头
    headers: {
      "Referer": "https://mock.yonyoucloud.com"
    },
    pathRewrite: {
      '^/mock/api' : '/new/api'
    },
    //本地路由代理到远端
    router: [
      '/mock'
    ],
    url: 'https://mock.yonyoucloud.com'
  }
]
```
可以看出，增加`pathRewrite`字段，`key`代表是我们本地要访问的代理路由，`value`是远端服务器被解析转换的路由，这样当我们访问了[http://127.0.0.1:3000/mock/api/842/action](http://127.0.0.1:3000/mock/api/842/action)后，会被解析为[https://mock.yonyoucloud.com/new/api/842/action](https://mock.yonyoucloud.com/new/api/842/action)
<a name="ZIkE4"></a>
### publicPath
指定资源文件引用的目录，打包目录上下文

- 示例1 
```javascript
publicPath："iuap-ypr/ucf-wh"

打包路径：ucf-publish/iuap-ypr/ucf-wh
图片路径：module.exports = "/iuap-ypr/ucf-wh/assets/images/ds.db271945.png";
图标字体路径：module.exports = "/iuap-ypr/ucf-wh/assets/images/icon.fdafasd.woff";
```

- 示例2
```javascript
publicPath:{
  output:'output',
  icon:'icon',
  img:'icon'
}

打包构建之后的路径：output/iuap-ypr/ucf-wh
图片：module.exports = "/icon/assets/images/ds.db271945.png";
```

<a name="lRB41"></a>
### templateType
入口文件的类型，默认为html，如果为html类型可以不传

- **用法：**

`template:ejs`
<a name="YjJtw"></a>
### global_env
项目内全局环境变量

- **用法**
```javascript

global_env: {
  'process.env': {
    'NODE_ENV': JSON.stringify(env),
  },
  'process.env.STATIC_HTTP_PATH': env == 'development' ? JSON.stringify("/static") : JSON.stringify("../static"),
  'FE_ENV': JSON.stringify(env),
},
```
<a name="VO61q"></a>
### alias
项目别名

- **用法**
```javascript
// 实例用法
alias: {
  "baseui": path.resolve(__dirname, 'ucf-common/src/baseui/'),
   module: path.resolve(__dirname, 'ucf-common/src/module'),
},
```
<a name="gn0VX"></a>
### extensions
内置以下后缀名
```javascript
[".ts", ".tsx", ".jsx", ".js", ".less", ".css", ".json",]
```

- **用法**

`extensions : []`
<a name="ZfgnP"></a>
### externals
**默认内置react、react-dom、@tinper/next-ui，如果只有这三个配置可以不配置**

- **用法**
```javascript
//实例用法
externals: {
    "tinper-bee": "TinperBee",
},
```

- 如果要覆盖内置参数，可参考下面
```javascript
externals(defaultExternals){
  // 删除 react 属性并创建新对象
  const { react, ...newExternals } = defaultExternals;
  
  // 添加 tinper-bee:TinperBee 属性
  const updatedExternals = { ...newExternals, "tinper-bee": "TinperBee" };
  return updatedExternals
}
```

- 如果需要在内置对象中追加，可参考下面
```javascript
//实例用法
externals: {
    "tinper-bee": "TinperBee",
},
-------------------------------
//最终实际配置
 {
  "react": "React",
  "react-dom": "ReactDOM",
  "@tinper/next-ui": "TinperNext",
  "tinper-bee": "TinperBee",
};
```
<a name="nU0Js"></a>
### limit 
打包图片图标的限制文件大小，如果不传limit，默认为limit：8196

- 数字参数

`limit : 8196`

- 对象参数

`limit:{img: 8196, icon: 8196}`<br />**limit = 8196 <=> limit = { img: 8196, icon: 8196 }**
<a name="QSKvS"></a>
### hash
构建模式下，打包文件添加文件指纹；打包的css或者js会添加hash值

- 数字参数

`hash : 8`

- 对象参数

`limit:{js: 5, css: 9}`
```javascript
988.b910d.js
188.b910dafc6.css
```
**hash : 8 <=> hash : { js: 8, css: 8 }**
<a name="xSAtQ"></a>
### devtool
webpack的devtool参数<br />开发模式默认为source-map<br />生产模式为false

- **用法**

`devtool:"source-map"`
<a name="WOOEQ"></a>
### static
静态http服务，用作本地不参与import加载的资源使用，类似webpack-dev-server里的contentBase，仅仅用于开发调试，请使用正确导入资源使用

- 用法

`static: "ucf-common/src/static"`
<a name="wbKnr"></a>
### scan_root
自定义文件夹作为扫描微应用入口，原则上是按照./自定义目录/*/src/app.js扫描

- **用法**

`scan_root："ucf-apps"`
<a name="z0l19"></a>
### dist_root
输出自定义文件夹，默认为ucf-publish

- **用法**

`dist_root: "ucf-publish"`
<a name="QkUcw"></a>
### host
自定义IP、域名启动，默认为'127.0.0.1'

- **用法**

`host:"127.0.0.1"`
<a name="hAuJ0"></a>
### tnsCfg
接入tns的参数<br />ucf-script接入

- UCF内置tns 插件，需要用户在tnsCfg指定 插件配置（详见tnsCfg）
- UCF内置原默认入口app.js, 需用户指定配置bootName并新建统一的入口名称、以及内容(多入口及在每个app.js同级目录创建新的入口文件，内容均为 import('./app'); );
- externals 需要在模板中手动使用外链的react reactDom Tinper 

详细见文档<br />[https://yundoc.yonyou.com/view/l/ttu798w](https://yundoc.yonyou.com/view/l/ttu798w)
<a name="ygmVZ"></a>
### webpackCfg
最后执行，复写定制最终的webpack配置

- 用法

需要修改output参数
```javascript
webpackCfg(Config){
  Config.library: `${name}-[name]`;
  Config.libraryTarget = "umd";
  Config.globalObject = "window";
  return Config
}
```
<a name="N1g5G"></a>
### loaderCfg
整合所有loader的配置，以前的less、css、loader、babel的参数都可以用这个配置做替代

- 用法1，扩展配置(推荐)
```javascript
loaderCfg(defaultLoaderOptions) {
    //含有以下配置项
    // let { less, css, postcss, babelInclude, babelPresets, babelPlugins, loaders } =
    //     defaultLoaderOptions;
    //添加css module
    defaultLoaderOptions.css.modules = true;
    //添加loader
    defaultLoaderOptions.loaders = [
        {
            test: /\.ejs$/,
            use: [
                {
                    loader: "ejs-compiled-loader",
                    options: {
                        compileDebug: true,
                    },
                },
            ],
        },
    ];

    return defaultLoaderOptions;
},
```

- 用法2，复写配置（不建议，容易引起内部异常）

```javascript
loaderCfg : {
    less: {},
    css: {},
    postcss: {},
    babelInclude: [],
    babelPresets: [],
    babelPlugins: [],
    loaders: [],
};
```

**以下为ucf-scripts内置loader的默认配置**
```javascript
const defaultLoaderOptions = {
    //css-loader默认配置
    css: {
        esModule: false,//禁用 ES 模块语法
        modules: false//禁用 CSS 模块
    },
    //postcss-plugins默认配置
    postcss: {
        postcssOptions: {
            plugins: [
                require("autoprefixer")({
                    overrideBrowserslist: [
                        "last 2 Chrome versions",
                        "last 2 Firefox versions",
                        "Safari >= 7",
                        "ie > 10",
                    ],
                }),
                require("postcss-flexbugs-fixes"),
                require("postcss-import"),
            ],
        },
    },
    //less-loader默认配置
    less: {},
    babelInclude: [
        path.resolve(".", "ucf-apps"),
        path.resolve(".", "ucf-common"),
        // path.resolve(".", scan_root),
        // path.resolve('.', 'node_modules/@babel/register'),
        path.resolve(".", "node_modules/ansi-regex"),
        path.resolve(".", "node_modules/strip-ansi"),
        path.resolve(".", "node_modules/ucf-scripts"),
        path.resolve(".", "node_modules/query-string"),
        path.resolve(".", "node_modules/split-on-first"),
        path.resolve(".", "node_modules/strict-uri-encode"),
    ],
    babelPresets: [
        [
            require.resolve("@babel/preset-env"),
            {
                targets: {
                    edge: "17",
                    firefox: "60",
                    chrome: "67",
                    safari: "11.1",
                    ie: "10",
                },
            },
        ],
        "@babel/preset-flow",
        "@babel/preset-react",
        "@babel/preset-typescript",
    ],
    babelPlugins: [
        [
            require.resolve("@babel/plugin-transform-runtime"),
            {
                corejs: false,
                helpers: true,
                regenerator: true,
                useESModules: false,
            },
        ],
        [
            require.resolve("babel-plugin-dynamic-import-webpack"),
            {
                helpers: false,
                polyfill: true,
                regenerator: true,
            },
        ],
        [
            require.resolve("@babel/plugin-proposal-decorators"),
            {
                legacy: true,
            },
        ],
        [
            require.resolve("@babel/plugin-proposal-class-properties"),
            {
                loose: true,
            },
        ],
        [
            require.resolve("@babel/plugin-proposal-private-methods"),
            {
                loose: true,
            },
        ],
        [
            require.resolve("@babel/plugin-proposal-private-property-in-object"),
            {
                loose: true,
            },
        ],
        [require.resolve("@babel/plugin-proposal-optional-chaining"), {}, "ucf-changing"], // 支持可选链
        [
            require.resolve("@babel/plugin-proposal-nullish-coalescing-operator"),
            {},
            "ucf-coalescing",
        ], // 支持双问号
        require.resolve("@babel/plugin-proposal-object-rest-spread"),
    ],
    loaders: [],
};
```
<a name="gWU6v"></a>
### pluginCfg

- 用法1 - 扩展配置
```javascript
pluginCfg(defaultPluginOptions) {
    //含有以下配置项
    let { 
      CopyWebpackPlugin, 
      CleanWebpackPlugin, 
      HtmlWebPackPlugin, 
      TerserPlugin,
      CssMinimizerPlugin 
    } =defaultPluginOptions;
  
    defaultPluginOptions.CopyWebpackPlugin =  {
        patterns: [
          { from: 'module.xml' },
          { from: 'README.md' }
        ]
    }

    return defaultPluginOptions;
},
```

- 用法2 - 复写配置
```javascript
pluginCfg : {
  CopyWebpackPlugin:{}, 
  CleanWebpackPlugin:{}, 
  HtmlWebPackPlugin:{}, 
  TerserPlugin:{},
  CssMinimizerPlugin :{},
  plugins:[]
}
```

- 区分生产模式或者开发模式plugins
```javascript
plugins : argv[0] === "build" ? [] : []
```
**以下为ucf-scripts内置plugin参数的默认配置**
```javascript
const defaultPluginOptions = {
    CopyWebpackPlugin: {

    },
    CleanWebpackPlugin: {},
    HtmlWebPackPlugin: {},
    TerserPlugin: {
        parallel: true,
    },
    CssMinimizerPlugin: {
        minimizerOptions: {
            mergeLonghand: false,
            discardComments: { removeAll: true },
        },
    },
    plugins: [],
};
```
<a name="fe2df04a"></a>
## 版本

- `2.0.0-beta.15` 内部放弃使用 optimize-css-assets-webpack-plugin 变更为css-minimizer-webpack-plugin 打包css
- `2.0.0-beta.13` 增加 对于typescript 的支持
- `2.0.0-beta.12` 增加 extensions 参数用于支持扩展extensions
- `2.0.0-beta.11` babel 增加同时使用esm和commonjs的兼容性， 兼容ie11；支持参数babel_include 为function类型
- `2.0.0-beta.8` css 编译 排除 less-loader
- `2.0.0-beta.7` tns 内置 libraryEnv 默认值
- `2.0.0-beta.6` 支持开发模式支持https启动服务
- `2.0.0-beta.5` tns 部分文档更新, tns 包升级
- `2.0.0-beta.4` tns 部分文档更新, fix bug
- `2.0.0-beta.3` 接入tns系统
- `2.0.0-beta.2` 修复背景图片以及一些字体打包问题
- `2.0.0-beta.1` 修复内部包 不能被外部全部直接下载问题，修复postcss 警告
- `2.0.0-beta.0` 内置webpack5
- `1.2.8` 增加limit参数，用于设置静态资源大于多少后进行base64转码
- `1.2.7` 修复启动端口冲突的问题
- `1.2.6` 增加less配置参数
- `1.2.5` 增加publicPath={boolen}字段，用于解决需要进行按需加载优化的项目，开启该配置后 项目中资源依赖路径将使用 context 字段作为资源依赖公共路径，并且路径依赖由原来的相对路径变为 /开头的绝对路径
- `1.2.4` 支持Less-Loader的JavaScript
- `1.2.3` 增加 `postcss_plugins` 参数用于支持扩展PostCss Loader的插件机制
- `1.2.2` 解决在使用了`context`后，静态资源地址不正确的问题以及静态资源根据开发环境不同加载对应的脚本
- `1.2.1` 支持自定义域名、IP绑定参数`host`、对应文档更新
- `1.2.0` 实现splitChunks参数暴露、版本号锁定
- `1.1.9` 解决启动`autoprefixer`红色警告的问题
- `1.1.8` 显示文件名和构建时间&新特性实现多级构建源码目录
- `1.1.7` 修复启动或构建执行三次配置文件的问题，修复第一次传递错误环境参数值
- `1.1.6` 增加自定义入口扫描`scan_root`、自定义输出目录`dist_root`
- `1.1.5` 支持`babel`的`presets`、`plugin`参数，更新对应使用文档，`ucf.config`增加`babel_presets`、`babel_plugins`
- `1.1.4` 升级`clean-webpack-plugin`、`get-port`，去除压缩插件`uglifyjs-webpack-plugin`使用内置压缩插件`terser-webpack-plugin`
- `1.1.3` 解决`res_extra`参数的差异化，现在不管是`development`还是`production`都是一致的路径
- `1.1.2` 完善`res_extra:true`性能优化，只针对构建上线打包的时候生效，拆分公共vendor、js、css
- `1.1.1` 修复静态服务没有设置的错误
- `1.1.0` 增加调试和打包的静态依赖资源展开参数`res_extra`,增加静态服务功能参数`static`
- `1.0.9` 修复context不设置构建的时候没有html文件的问题
- `1.0.8` 增加context参数
- `1.0.7` 调整参数变化、输出目录调整ucf-publish、自动清理构建目录
- `1.0.6` 增加portal平台开发环境支持
- `1.0.5` 增加对CSS Loader配置支持
- `1.0.4` 增加CSS Modules支持、自动打开浏览器命令行`--homepage`
- `1.0.3` 增加注解支持
- `1.0.2` 增加SourceMap参数支持
- `1.0.1` 切换正式环境
- `1.0.0` 完善开发服务、精简配置、容错处理
- `0.0.x` 初步完成开发调试、构建、代理访问
